<?php
/**
 * Created by PhpStorm.
 * Script Name: BaseCtl.php
 * Create: 2020/9/4 下午10:10
 * Description: 公共控制器基类
 * Author: fudaoji<fdj@kuryun.cn>
 */

namespace app\common\controller;

use think\Controller;

class BaseCtl extends Controller
{
    protected $assign = [];
    protected $module;
    protected $controller;
    protected $action;
    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        $this->isInstalled();
        model('common/setting')->settings();

        $this->module = strtolower(request()->module());
        $this->controller = strtolower(request()->controller());
        $this->action = strtolower(request()->action());
    }

    /**
     * 统一视图
     * @param string $view
     * @param array $assign
     * @return mixed
     * @Author  fudaoji<fdj@kuryun.cn>
     */
    public function show($assign = [], $view = ''){
        $this->view->config('view_path', env('root_path').'themes/' . $this->module.'/'.config('theme'). '/');

        $assign['module'] = $this->module;
        $assign['controller'] = $this->controller;
        $assign['action'] = $this->action;
        $assign['static_version'] = config("app_debug") ? time() : config('version');

        $this->assign = array_merge($this->assign, $assign);

        if (!$view) {
            $view = $assign['action'];
        }
        return $this->fetch($view, $this->assign);
    }

    /**
     * 方法不存在的时候
     * @param $name
     * @author: fudaoji<fdj@kuryun.cn>
     */
    public function _empty($name){
        $this->error($name . '方法不存在');
    }

    protected function getAjax()
    {
        $json = file_get_contents("php://input");
        return json_decode($json, 1);
    }

    public function isInstalled(){
        $root_path = app()->getRootPath();
        if (!is_file($root_path . '.env') || !is_file($root_path . '/install.lock')) {
            $this->redirect('install/index/index');
        }
    }
}