<?php
/**
 * Created by PhpStorm.
 * Script Name: Wx.php
 * Create: 12/20/21 11:42 PM
 * Description:
 * Author: fudaoji<fdj@kuryun.cn>
 */

namespace ky\WxBot;


class Wx extends Base
{
    protected $baseUri = 'http://116.62.202.87:8889/';

    public function __construct($options = [])
    {
        parent::__construct($options);
    }

    public function setAppKey($app_key = ''){
        $this->appKey = $app_key;
        return $this;
    }

    /**
     * 拉取群成员
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function pullGroupMembers($params = []){
        $url = '/user/group/members';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey],
            'data' => $params['data']
        ]);
    }

    /**
     * 群发视频
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function sendVideoBatch($params = []){
        $url = '/message/batch/video';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey],
            'data' => $params['data']
        ]);
    }

    /**
     * 群发文件
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function sendFileBatch($params = []){
        $url = '/message/batch/file';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey],
            'data' => $params['data']
        ]);
    }

    /**
     * 群发图片
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function sendImgBatch($params = []){
        $url = '/message/batch/img';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey],
            'data' => $params['data']
        ]);
    }

    /**
     * 群发文本
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function sendTextBatch($params = []){
        $url = '/message/batch';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey],
            'data' => $params['data']
        ]);
    }

    /**
     * 移除群成员
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function removeMembersFromGroup($params = []){
        $url = '/user/group/removemembers';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey],
            'data' => $params['data']
        ]);
    }

    /**
     * 邀请好友入群
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function addFriendsIntoGroup($params = []){
        $url = '/user/addfriendsintogroup';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey],
            'data' => $params['data'] //{to: "", content:"", type:"image"}
        ]);
    }

    /**
     * 发送文件给群聊
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function sendFileToGroup($params = []){
        $url = '/message/group/file';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey],
            'data' => $params['data'] //{to: "", content:"", type:"image"}
        ]);
    }

    /**
     * 发送文件给好友
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function sendFileToFriend($params = []){
        $url = '/message/user/file';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey],
            'data' => $params['data'] //{to: "", content:"", type:"image"}
        ]);
    }

    /**
     * 发送图片给群聊
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function sendImgToGroup($params = []){
        $url = '/message/group/img';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey],
            'data' => $params['data'] //{to: "", content:"", type:"image"}
        ]);
    }

    /**
     * 发送图片给好友
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function sendImgToFriend($params = []){
        $url = '/message/user/img';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey],
            'data' => $params['data'] //{to: "", content:"", type:"image"}
        ]);
    }

    /**
     * 发送文本消息给群聊
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function sendTextToGroup($params = []){
        $url = '/message/group';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey],
            'data' => $params['data'] //{to: "", content:"", type:"text"}
        ]);
    }

    /**
     * 发送文本消息给好友
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function sendTextToFriend($params = []){
        $url = '/message/user';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey],
            'data' => $params['data'] //{to: "", content:"", type:"text"}
        ]);
    }

    /**
     * 设置好友备注名
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function setFriendRemarkName($params = []){
        $url = '/user/setfriendremarkname';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey],
            'data' => $params['data']
        ]);
    }

    /**
     * 获取当前用户的群组列表
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function getGroups($params = []){
        $url = '/user/groups';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'get',
            'headers' => ['AppKey' => $this->appKey]
        ]);
    }

    /**
     * 获取当前用户的好友列表
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function getFriends($params = []){
        $url = '/user/friends';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'get',
            'headers' => ['AppKey' => $this->appKey]
        ]);
    }

    /**
     * 获取当前用户信息
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function getCurrentUser($params = []){
        $url = '/user/info';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'get',
            'headers' => ['AppKey' => $this->appKey]
        ]);
    }

    /**
     * 验证登录情况
     * @param array $params
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function checkLogin($params = []){
        $url = '/checklogin';
        return $this->request([
            'url' => $url . '?uuid=' . $params['uuid'],
            'method' => 'post',
            'headers' => ['AppKey' => $this->appKey]
        ]);
    }

    /**
     * 获取登录二维码
     * @return bool|mixed
     * Author: fudaoji<fdj@kuryun.cn>
     */
    public function getLoginCode(){
        $url = '/getlogincode';
        return $this->request([
            'url' => $url,
            'method' => 'get',
            'headers' => ['AppKey' => $this->appKey]
        ]);
    }

    public function dealRes($res){
        return $res;
    }

    public function forwardMsg($params = [])
    {
        // TODO: Implement forwardMsg() method.
    }

    public function sendImgToFriends($params = [])
    {
        // TODO: Implement sendImgToFriends() method.
    }

    public function sendTextToFriends($params = [])
    {
        // TODO: Implement sendTextToFriends() method.
    }

    public function sendVideoToFriends($params = [])
    {
        // TODO: Implement sendVideoToFriends() method.
    }

    public function sendVideoMsg($params = [])
    {
        // TODO: Implement sendVideoMsg() method.
    }

    public function sendFileToFriends($params = [])
    {
        // TODO: Implement sendFileToFriends() method.
    }

    public function sendFileMsg($params = [])
    {
        // TODO: Implement sendFileMsg() method.
    }

    public function sendMusicLinkMsg($params = [])
    {
        // TODO: Implement sendMusicLinkMsg() method.
    }

    public function sendShareLinkToFriends($params = [])
    {
        // TODO: Implement sendShareLinkToFriends() method.
    }

    public function sendShareLinkMsg($params = [])
    {
        // TODO: Implement sendShareLinkMsg() method.
    }

    public function sendLinkMsg($params = [])
    {
        // TODO: Implement sendLinkMsg() method.
    }

    public function sendCardMsg($params = [])
    {
        // TODO: Implement sendCardMsg() method.
    }

    public function deleteFriend($params = [])
    {
        // TODO: Implement deleteFriend() method.
    }

    public function agreeFriendVerify($params = [])
    {
        // TODO: Implement agreeFriendVerify() method.
    }

    public function searchAccount($params = [])
    {
        // TODO: Implement searchAccount() method.
    }

    public function addFriendBySearch($params = [])
    {
        // TODO: Implement addFriendBySearch() method.
    }

    public function sendGroupMsgAndAt($params = [])
    {
        // TODO: Implement sendGroupMsgAndAt() method.
    }

    public function removeGroupMember($params = [])
    {
        // TODO: Implement removeGroupMember() method.
    }

    public function inviteInGroup($params = [])
    {
        // TODO: Implement inviteInGroup() method.
    }

    public function getGroupMemberInfo($params = [])
    {
        // TODO: Implement getGroupMemberInfo() method.
    }

    public function getGuest($content = [])
    {
        // TODO: Implement getGuest() method.
    }

    public function forwardMsgToFriends($params = [])
    {
        // TODO: Implement forwardMsgToFriends() method.
    }
}